0.20.0:
Mastodon: Fix profile update dialog for instances that may have more than 4 fields.
Mastodon: Auto add https schema if not provided.
Mastodon: Fix blank items when navigating over boosts on remote instance timelines.
Mastodon: Fix error when updating conversations where the last status was deleted.
Mastodon: Hopefully fix loading bookmarks.
0.19.0:
Mastodon: Switch to in-house library, replacing mastodon.py.
Mastodon: Switch uploads to API V2, and wait for media processing to finish before posting.
Mastodon: Added formatting for quoted posts.
Mastodon: Add support for quoting posts.
Mastodon: Add lists support.
Mastodon: Reimplemented streaming using a new streaming backend, fixing duplicating items in buffers.
Mastodon: Add an advanced config option for automatic loading of previous items.
Mastodon: Add support for playing audiopub.site URL's directly in TweeseCake.
Mastodon: Fix viewing conversations from remote instances.
Mastodon: Fixes a bug where boosted posts sometimes didn't play the respective earcon (mainly polls) when you moved over them.
Mastodon: Fix update profile view to show when 4 fields are filled.
Mastodon: Fix editing posts removing attachments.
Mastodon: Various bug fixes and code cleanup.
Telegram: Update library and fixed breaking changes.
Telegram: Add topics support.
Telegram: Added shared media buffer.
Telegram: Bump max message limit.
Telegram: Fix sending files to channels.
Feeds: Fix feeds session so that Bluesky RSS feeds work.
Feeds: Fix typo in playing episode.
0.18.0:
Core: Hopeful improvement by bumping the delay of the speak long items option.
Core: Add a config toggle for allowing volume boost above 100%.
Homeassistant: Add support for fans.
Mastodon: Adds ability to update your profile. Control+Alt U in the window, or by default, control+windows+Alt U in the invisible interface.
Mastodon: Adds ability to view the local timeline of remote instances.
Mastodon: View instance on a remote timeline now shows the info for that instance.
Mastodon: Fixes a bug that showed duplicate URL's on reblog posts when selecting a URL to open.
Mastodon: Fixes copying from notifications buffer/mentions buffer.
Mastodon: Add a cancel button to the follow request confirmation prompt, in case you don't actually want to take any action.
Mastodon: Allow DM on notifications buffers.
Telegram: Fixes bug with not being able to resume after pausing voice messages.
Telegram: Include reaction count with each reaction type in the view dialog.
0.17.3:
Mastodon: Fix for editing posts and unexpected things other than usernames being expanded in some instances.
Mastodon: Make alt text edit box multi line.
Telegram: All new view message dialog with tons more info about a message.
Telegram: Fix forwarding.
Telegram: Fix replying to messages.
Telegram: Fix blocking.
0.17.2:
Core: Hopefully fixes issue that meant you'd lose your config in certain situations.
Mastodon: Fixes a bug where if you had any of the filtered settings enabled for the home timeline, load previous wouldn't respect them.
Mastodon: Add confirmation for blocking/unblocking users.
Mastodon: When pulling up a conversation from a boosted post, view the conversation for the original post rather than the boost.
Mastodon: Finally usernames are properly expanded when viewing posts, editing them, or copying them to your clipboard.
Mastodon: Adds OCR for images.
Mastodon: Add sounds for voting on polls, a poll earcon and an earcon for image posts.
Mastodon: Add link preview with microlink. Alt L in the window, or control windows L in the invisible interface.
Telegram: Add file size to files, videos and audios when reading the message.
Telegram: Add proper duration display to voice notes/audio.
Telegram: Updates library to latest version; hopefully fixes unsupported reply messages. Please report any oddities.
Radio: Add ability to view metadata in a text dialog.
0.17.1:
Core: Now it is possible to boost the volume of playing media (Mastodon attachments, voice messages/audio attachments on Telegram, local files played in file explorer, radio, etc) to above 100%. If you stop playback and start playback of a new item, in the name of hearing safety, the volume will be reset back to 100%. Your volume will not be touched if you have it at or below 100%.
Config: Remove send longer items to screen reader option on Mac, as we already do this so we don't need to do it twice.
Config: Removes speak through NSSS option on Mac. It never worked and NSSS is depricated.
Feeds: Persist open feeds across restarts.
Mastodon: More robust clearing of items on startup. This fixes several long standing bugs with the clear posts at startup option, where for example notifications would show as no status, or mentions and messages wouldn't read.
Mastodon: Remove the conversation updated message from conversation buffers.
Mastodon: Persist spoiler text in thread mode.
Mastodon: Add two new options to hide boosts and replies from home timeline. Note that due to the nature of this feature, any boosts and replies added to the buffer while this feature is disabled will not be removed. It will only apply to new items only. Likewise, if new boosts and replies are filtered by this feature, the only way to get them to be added is to clear the database.
Mastodon: Add option to remove emojis from post text.
Mastodon: Fix duplicated playable media in boosted posts.
Mastodon: Fixes interacting with boosted posts.
Mastodon: Focus the read only edit field on Mac OS.
Mastodon: Update open on web function to work in more instances.
Mastodon: View post and view post summary now open the original post if it's a boost. This fixes media with descriptions not viewing in the view dialog.
Mastodon: Change hide/show boosts keys on mac from command H/command shift H to option H/Option shift H.
Radio: Make the play random station hotkey not stop the previously playing station before switching to a new one.
0.17.0:
Core: Add a way to jump up and down in buffers by a configurable amount of items. In the invisible interface, by default, this is control windows page up and down. In the GUI, it's control page up and down.
Core: Add ability to export a buffer to a text file.
Feeds: Fix loading other feeds if one fails to load.
Feeds: Allow for reading feed entries that have no description.
Feeds: No longer freeze the app when adding and deleting feeds.
Homeassistant: Sort entities in domain buffers.
Mastodon: Rename private to followers only to be more in line with other Mastodon apps.
Mastodon: Fix viewing boosted posts.
Mastodon: Allow adding alt text/descriptions to an attached file. A box now comes up once you select a file asking you for alt text.
Mastodon: Complete rewrite of the audio handling system. This now means that we attempt to play mastodon video posts as well as audio, as well as external media types (Sndup, dropbox, stream, Youtube, more!)
Mastodon: Record audio directly to Mastodon with the addition of a new attach recording button. Also record to stereo option added to mastodon config.
Mastodon: Fixes viewing post summary in the mentions buffer.
Mastodon: Attempt at fixing favorites/bookmarks
Mastodon: Allow viewing and voting on polls.
Mastodon: I believe I've fixed a bug in the Messages buffer where if you reply to a conversation, it'll possibly disappear and then come back later.
Mastodon: Cosmetic changes to how media is shown in the view dialog/summary.
Mastodon: Mastodon media URLs are now part of the open URL feature.
Mastodon: Fix autoreading buffers when streaming.
Telegram: Fixes a long standing bug where some links in Telegram messages refused to open properly, claiming you'll need a new app to open this ttps link.
Telegram: Fix joining with invite link.
0.16.3:
Core: On a Mac, if speech is unable to be initialized through VoiceOver, we now try to initialize the default system voice and speak through that. This fixes a bug in Mac OS Sonoma betas 1 and 2 where you could not use TweeseCake.
Mastodon: Adds mentions buffer!
Mastodon: Mentions are no longer displayed in the notifications buffer. Note: If you want this to apply fully, clear your notifications buffer. It won't hurt anything if you don't.
Mastodon: Visibility is now included in the default toot template. Note: If you want this new template to apply, go to your mastodon config, find Toot Template, interact with it, hit the restore default button, then save.
Mastodon: Add support for languages in posts. To set post language, click the Set Post Language button and select your language from the list that appears. By default the language is set to English. Also, the new $language placeholder was added to the toot template. It is not included in the default template though.
Mastodon: Play the send_dm sound if sending a direct reply.
Mastodon: Attempt fix of bookmarks/favorites buffers.
Mastodon: Make it possible to mention users from different types of notifications.
0.16.2:
Mastodon: Fix unnecessary calls to the API when fetching notifications.
0.16.1:
Mastodon: Made speak reference respect the post template.
Mastodon: Fix loading notifications.
Mastodon: Make autocomplete ignore pre-filled users when replying.
Mastodon: Fix edit post in the GUI.
0.16.0:
Core: Always return to previously focused buffer on dismiss.
Core: Make context-aware volume control check if something is playing. This fixes the issue with voice message volume changing even if the voice message has finished.
Core: Bump up auto announcements of longer items by 20 MS.
Core: Updated Leasey keymap to latest version.
Homeassistant: In the logbook, convert event states with date times into proper TC parsed date time display.
Mastodon: Removes unofficial quoting support. You can still view them in the same ways you have been able to.
Mastodon: Hopefully fix the bug that inserted your own name into replys.
Mastodon: Adds ability to autocomplete usernames.
Mastodon: You can now hear when there is audio and play it from the notifications buffer.
Mastodon: Remove the need for the content warning check box. It was unnecessary. Now, if you leave the box blank, there is no warning, otherwise there is.
Mastodon: Significant improvements to how content is loaded in, specifically content quantity when fetching previous and initial loads. This should fix Ashley's problem where she would get 800+ items back in the home timeline, while also allowing fetch previous to load more items at a time.
Mastodon: There is now an option to set how many API calls loading posts uses.
Mastodon: Loading previous posts now happens without causing the program to lock up.
Mastodon: Interact with a follow request notification to accept or reject it.
Mastodon: Add ability to edit posts.
Radio: Added ability to view the last 50 songs played.
Telegram: Fix downloading photos.
Twitter: Added ability to set custom app keys in the global config session. Note that from this point, this session is not supported and you can use it at your own wrisk.
0.15.1:
File explorer: Fix file encoding when opening text files in TweeseCake.
Homeassistant: Added support for pressing buttons.
Mastodon: Fix bookmarks buffer not pulling new bookmarks.
Telegram: Fix copying messages.
Telegram: Fix forwarding messages.
Twitter: Use Mac key on both platforms. Probably won't last for long.
0.15.0:
Config/Core: Add an item to the config session that determines if longer buffer items are sent directly to the screen reader after a very tiny delay when navigating in the GUI. This avoids NVDA cutting off list items that are too long. Thanks Valiant8086 for reporting.
Core: Hopefully fix conflicting configs when replacing a session. For example, when switching to a new Mastodon instance and replacing your session, re-launching TweeseCake may have lost your authentication.
Mastodon: Add ability to send a DM to a focused user.
Mastodon: Make reply keystroke as well as DM keystroke work on user buffers.
Mastodon: Add experimental support for viewing and posting unofficial Mona and others style mastodon quotes! Note! You have to use the view post dialog or view the conversation of a quoted post in order to view the respective post, it will not be expanded for you automatically.
Mastodon: Make the home buffer load more items, specifically in the use case of starting the app after having it unloaded for a while.
Telegram: Created our own Telegram lib. Most things should be the same, with a number of improvements. Please report any oddities.
Telegram: Now allows multiple sessions again.
0.14.2:
Core: Added Leasey keymap. Thanks to JamminJerry for the contribution!
Homeassistant: Add ability to change a light color using the select option hotkey.
Mastodon: Use our own user agent.
Mastodon: Changed the way we retrieve character limits to hopefully work with more instances.
0.14.1:
Mastodon: Adds searching for hashtags support, as requested by Jonathan Mosen for the upcoming MushroomFM Holiday Countdown!
Mastodon: Fix playing the correct sound when sending replies.
Telegram: Add message template.
Twitter: Fix playing the correct sound when sending quotes/replies.
0.14.0:
Feeds: Fixed an issue with feeds that don't give a publish date on entries.
Mastodon: Fix new post dialog and reply dialog locking up the application.
Mastodon: Re-open post/reply dialog if an error is raised.
Mastodon: Add messages buffer!
Mastodon: Fix favorite hotkey in GUI.
Mastodon: Fix view profile button in the view post dialog.
Mastodon: Add show/hide boosts hotkeys.
Mastodon: Correctly count content warnings toward the character limit of your post.
Mastodon: Corrects context menu options.
Mastodon: Removes streaming error messages.
Mastodon: Error handling for no search results.
Mastodon: Add profile directory.
Mastodon: Update user profile dialog to be more aware of the relationship between users.
Telegram: Include caption on voice messages.
Twitter: Add ability to mention a user from a user buffer using the reply function.
Twitter: Re-open reply and quote dialogs on error.
Twitter: Stop new tweets, quote tweets and replys locking up the application.
Twitter: Fix thread mode after quoting a tweet.
0.13.4:
Mastodon: Now pull image descriptions from boosted posts.
Mastodon: Fix opening some URLs.
Mastodon: Add user buffers, replacing the view users dialogs!
Mastodon: Show way more info on a user in the profile dialog.
Mastodon: Adds post and user search. Note: Post search will more than likely be empty, most instances don't support full text search from what I could tell and I've never managed to get any results back from it.
Mastodon: Adds support for bookmarks.
Mastodon: Adds trending hashtags buffer! Use interact on a hashtag in this buffer to open a hashtag timeline, and secondary interact to open a local hashtag timeline (posts only from your instance).
Mastodon: Change default instance to tweesecake.social.
Mastodon: Fix nicknames not persisting.
Mastodon: Remove time from date display if it wasn't provided.
0.13.3:
Core: Fixed an issue with buffer templates.
0.13.2:
Config: Created a dedicated template edit dialog that includes a button to restore the default template and a button to insert the available placeholders for the given template.
Docs: Add section on interaction to each session type.
Mastodon: More improvements to posts and blank lines.
Mastodon: Fixes replying to users on other domains.
Mastodon: Add an option to include the text of a post with a CW after the CW.
Mastodon: When replying to boosted post, reply to the person being boosted, and not the person who boosted the post.
Mastodon: When reading a boosted post, strip emojis from names of boosted users if strip emojis setting is enabled. Also, properly include username as the second name, not duplicate the full name again.
Mastodon: Add visibility for post templates (not in the default template).
0.13.1:
Mastodon: Fixes a bug that meant you could not reply to old style toots in your database.
Mastodon: Fix windows 11 keymap.
0.13.0:
Docs: Added Mastodon disclaimer
Mastodon: Adds deleting of posts.
Mastodon: Starts work on streaming!
Mastodon: Add clearing of buffers and auto clear posts at startup.
Mastodon: Add user aliases.
Mastodon: Add config option to show screen names.
Mastodon: Notifications buffer now respects emojis/name substitutions.
Mastodon: Notifications buffer now can detect direct mentions (DM's).
Mastodon: Add ability to copy posts to clipboard.
Mastodon: Add ability to add image description readouts to your post template!
Mastodon: You can now view media in the view post dialog much like you would in Twitter.
Mastodon: Rename all instances of "Toot" to "Post".
Mastodon: Add key to view info on your instance.
Mastodon: Show who you're replying to in the reply dialog title bar.
Mastodon: Better handling of media and textual URL's in boosted posts.
Mastodon: Rename public timeline to Federated timeline.
Mastodon: Fixes a bug where if you replied to a notification, a content warning would not be included if there was one originally.
Mastodon: Performing functions such as follow, unfollow, user profile and timeline should be more reliable and snappy.
Mastodon: Recodes how replying works, to make it show the at handles of users you're replying to in the reply box. This also fixes the bug where you would reply to a boosted post and it would reply to the person who originally posted the post, not the booster.
Mastodon: Fixes a bug where if you tried to see what the referencing post was when in the notifications buffer, it just said no reference.
Mastodon: You can now pick a server emoji to insert into your text!
Mastodon: Show full server URL in mastodon session title.
Mastodon: Improved conversation buffers! Your starting position is now at the position of the post in which you load the conversation from. Boosted posts now show original post!
Mastodon: Include user bio in follow notifications.
Mastodon: Add shortcut key to post button.
Mastodon: Even more improvements to URL opening.
Mastodon: Add open post on web functionality.
Twitter: Include user bio in follow event like Mastodon.
0.12.3:
Mastodon: Updated login flow to use oauth. Supports 2FA, ETC.
Mastodon: Add toot visibility combo box to new toot dialog.
Mastodon: add conversation buffers.
Telegram: Fix voice message dialog focus on Mac.
Twitter: Show unknown user if a user cannot be found for the events buffer.
Twitter: Add like/unlike to the context menu.
0.12.2:
Homeassistant: Add support for activating scenes.
Telegram: Fixes voting in polls.
Twitter: Fix user buffers not showing items in the GUI.
Twitter: Make block buttons in user profile dialog actually respect blocked status. Note: If you've recently blocked somebody, the block status may not update right away.
Twitter: Add report user as spam button to profile dialog.
Twitter: Another attempted fix for the blank items in the events buffer.
0.12.1:
Core: Change buffer mute hotkey on Mac to control M and mute sounds hotkey to control shift M.
Twitter: In windows 11 keymap, changes like/unlike hotkey to windows alt I/windows alt shift I to avoid conflicting with the microphone mute shortcut.
Twitter: Fix for blank event items.
Twitter: Fix image descriptions not showing in the view tweet dialog.
0.12.0:
Config: Properly implemented the session config option so that it appears at the bottom of the context menu. The undocumented session config option that appeared at the top of the context menu in the previous version was never even supposed to be there.
Telegram: If you press escape on the caption prompt of an upload file dialog, the action now properly aborts.
Twitter: Pretty major changes with the way users are displayed. No longer are the users displayed in their own dialog. Now, as you'd probably expect, users now display in their own buffer! Everything that previously used the user viewer dialog now uses the new user buffer system. In addition, user summaries no longer use text buffers but an actual user buffer. This allows for you to interact with users in a user summary, just like you would on any other tweet!
Twitter: Add templates for the way users are displayed in the new users buffers.
Twitter: User Viewer dialog is no longer required for displaying lists of users, so it no longer does so. It is only now used for displaying a user's profile. Very slightly modernized the dialog. More to come in the future!
Twitter: Add keys and context menu items to show/hide retweets for a user.
Twitter: Add an option to automatically select the first user in a user select dialog. This allows for completely dialogless user management/interaction!
Twitter: Fixes a long standing bug which meant some tweets didn't show an image description when they very clearly had an image when viewing a summary.
Twitter: Add new keys to show followers you haven't followed and friends who haven't followed you (User analysis).
Twitter: Add events buffer for follow/unfollow notifications.
0.11.5:
Config: Add item to session-related config buffers that will return you to the session being configured.
Github: Always return to last buffer when viewing a repository's commits, files, releases or issues.
Telegram: Escaping out of a recording dialog without stopping will no longer fill your disk with a massive wav file.
Twitter: Add block/unblock buttons to user viewer dialog.
Twitter: Add API V1.1 fallback to following/unfollowing users.
Twitter: Add option to clear the tweets database at start-up.
0.11.4:
Core: Updated youtube lib.
Core: Fix position in the buffer after an item is removed. Most noticeable in Telegram; sometimes the position would go wild.
Telegram: Add a preference for the spoken chat loaded message.
Telegram: Only announce when all chats are loaded after startup.
Telegram: Add ability to clear and and delete a chat from the chats buffer (option when using delete hotkey).
Telegram: Fix certain actions (E.G. Blocking, telegram link) from blocking the application when using the GUI.
Telegram: Improved error handling at start-up. Timeouts will automatically retry and errors (should) show the correct message.
Telegram: Update lib to hopefully stop recent crashes.
0.11.3:
Telegram: Fix auto download for audio and voice messages.
Telegram: Add a spoken message when a chat buffer is fully loaded.
Telegram: Add ability to forward messages.
Telegram: Mark message content as opened, such as a voice message being played.
0.11.2:
Core: Hopefully fix TweeseCake not exiting properly on MacOS.
Core: Fix issue that prevented shutdown.
Core: Removes ask to exit on MacOS, as it broke more than it fixed.
Telegram: Disable storage optimizer and keep original file names.
Telegram: Always get latest online status.
Telegram: Fix session not saving phone number.
0.11.1:
Core: Change the title of the update available dialog, to make it more apparent where its coming from.
Telegram: Fix GUI not showing chats after they've loaded.
Telegram: Set online/offline status when the session is focused or unfocused, respectively.
Telegram: Add bio.
0.11.0:
Core: Fix order dialog.
Core: Fix sound errors breaking the application.
Telegram: Rewrite entire telegram session. Most things should be the same, with a number of improvements. Please report any oddities.
Telegram: Support 2FA password at login.
Telegram: Loading chats will no longer block.
Telegram: Improved status displays.
Telegram: Report number of unread mentions in chat status.
Telegram: Report block state in chat status.
Telegram: Add ability to block/unblock users.
Telegram: Mark mentions as read when marking a chat as read.
Twitter: Fix update profile dialog.
Twitter: Stop blocking when loading previous tweets and add anouncement.
0.10.1:
Core: Change session-switching keys on MacOS to option+numbers, as CMD+Shift+numbers was conflicting.
Github: Fix session name in the GUI after startup (thanks scott for the report!).
Homeassistant: Added support for the input_boolean entity type.
Homeassistant: Implemented a workaround to add sonos favorites back to the sonos media player source lists. Note that the sensor.sonos_favorites sensor should be enabled for this to work.
Homeassistant: Added favorite lists for grouping entities.
Telegram: Show full names for users no longer requires a restart.
Twitter: Stop streaming a users tweets to the home buffer if they've been unfollowed. Note that this only applies if you unfollow said user from within TweeseCake itself for now.
Twitter: Fix playing audio on direct messages.
Twitter: Add ability to copy direct messages to the clipboard.
Twitter config: Added option to show full URLs in tweets when navigating buffers.
0.10.0:
Core: Add useful messages to the log if the database breaks.
Core: Add local key activation during startup.
Core: More session updates to decrease start-up time.
GUI: Announce if the window is hidden or visible when using the toggle window hotkey.
Mastodon: Pretties up toot display. Posts with new lines and paragraphs now format properly.
Telegram: Attempt to remove deleted messages from buffers.
Twitter: Fix ability to OCR retweeted tweets.
Twitter: Added ability to search for users.
0.9.12:
Core: Fix issue with being unable to remove some session types if setup is incomplete.
Homeassistant: Fix an error when an entity is unavailable.
Telegram: Fix persisting voice message volume.
Twitter: Fix blocked users still showing up if streaming is enabled.
0.9.11:
GUI: Make sure to set names of sessions properly when loading in the GUI.
0.9.10:
Core: Fix bug from the last update that stopped items from being removed from buffers.
Core: Stop repeating current item in a buffer on MacOS when said buffer is updated.
Core: Massively improved start-up time for instances with lots of sessions.
Homeassistant: Add water heater support.
Telegram: Fix pausing voice messages.
Twitter: Play sound when activating the timeline button in the user dialog.
0.9.9:
Config: Don't display keymap option on MacOS, since its not actually used.
Core: Reset position in buffer if out of range.
Mastodon: Fixes a bug where if you don't have a sync position, you don't get toots in your home buffer.
Mastodon: Add option to remove emojis from display names.
Telegram: Tell Telegram to ignore secret chats for this application, as we do not currently support this.
Telegram: Add support for editing messages and showing when messages were edited.
Telegram: In channels, don't display a user (Other) before message contents, as no user is ever given.
Telegram: You can now see if your message is read or not.
Telegram: Don't play mention earcon if the reply is your own message (Thanks Scott for suggestion.)
Telegram: Remove deleted messages from buffers.
Telegram: Use media volume hotkeys to adjust voice message volume while one is playing.
Twitter: Add option to disable started streaming notifications (Thanks Aciath for suggestion).
0.9.8:
Config: Add new sound buffer with options to set audio devices.
Config: Move audio-related config to the new sound buffer.
Homeassistant: Add support for new update domain.
Radio: Attempt to automatically re-start playback if the stream drops.
0.9.7:
Core: Fixes absolute time display.
Core: Make buffer mute toggle less verbose, Telegram already did this.
Core: Add starts with filter type.
Github: Sort repos in Github repo buffers by date pushed, not updated.
Github: Support showing open/closed/all issues.
Radio: If unable to load Radio-Browser, don't freeze the app and disable searching for stations.
Telegram: Include chat name in title of voice message dialog.
Twitter: Re-open the tweet dialog if it failed to post.
0.9.6:
Config: Add option to open a URL automatically if it's the only one in the list.
Core: Unify URL selection behavior across all sessions.
Core: Fix MacOS update URLs and give option to switch to M1 build if running emulated.
GUI: Add control+C shortcut to URL selector to copy the selected URL to your clipboard.
0.9.5:
GUI: Announce when moving between sessions and buffers with GUI hotkeys.
Twitter: Another tentative fix for streaming breaking during backup.
0.9.4:
Core: Add native Mac M1 builds.
Core: Lots of core code changes to improve performance.
File explorer: Hide system folders.
Twitter: Tentative fix for streaming when the database is backing up.
0.9.3:
Core: Automaticly backup databases every half an hour.
Core: If there is an error while loading the database, attempt to restore from a backup else delete the broken files.
Github: Add ability to open a repository on the web.
Github: Speak when buffers are opened.
Telegram: Play mention earcon upon receiving a reply/mention message.
Telegram: Add an option to automatically start recording when Voice message dialog opens.
Telegram: Enable send button to directly stop and send a voice message.
Twitter: Notify user of a failed tweet instead of failing silently.
0.9.2:
Core: Use control (Command on Mac OS) and numbers as well as dash and equals to quickly switch between buffers.
Core: Use control shift numbers as well as dash and equals to quickly switch to sessions.
Core: Support ZDSR screen reader on Windows.
GUI: Use F1 to access online documentation.
Homeassistant: Add ability to toggle script domain.
Twitter: Changed parentheses in replies to comma.
Twitter: If replies aren't actually part of a thread, it no longer tries to treat them as a reply thread.
Twitter: Added an option to disable the new reply method altogether if you don't like or want it.
Twitter: Likes buffers now persist.
Twitter: Fix autocomplete for multiple users.
Twitter: Fix deleting own tweets not removing from buffers.
Twitter: Update name length in update profile from 20 to 50.
0.9.1:
Telegram: Fixes voice messages.
0.9.0:
Core: Major memory (RAM) improvements for buffers with large amounts of items.
Core: Prevent exiting more than once.
GUI: Fix field focus on MacOS.
Homeassistant: Adds ability to manage your smart home using a homeassistant session.
Mastodon: Fix bug with boosted toots and content warnings.
Telegram: Interacting with a chat that already has a buffer open will now focus that buffer, rather than doing nothing.
Telegram: Add support for downloading images and videos.
Telegram: Handle animated emojis.
Telegram: Fixes view dialog for other message types other than text.
Telegram: Add copy message hotkey.
Telegram: Add support for polls (Viewing and voting)
Telegram: Say what message is pinned.
Telegram: Add viewing of pinned message and pinning of message.
Twitter: Notify user that a tweet author is protected rather than allowing to quote/retweet.
Twitter: The option to remove emojis from display names now only removes emojis, not accented and other foreign characters.
Twitter: Fix autocomplete users.
Twitter: Force absolute date/time on view tweet dialog.
Twitter: Add quote action to actions menu.
Twitter: Remap actions hotkey from command A on Mac to command T to allow for select all.
Twitter: Slightly improve conversation handling.
0.8.3:
Core: On Mac OS, the order of UI elements in most if not all dialogs is majorly improved.
Core: Automatically re-initialize sound after system audio is stopped (E.G. waking after standby).
Telegram: Notify user of a deleted message rather than showing nothing.
Telegram: Add sponsored message support to channels as required by Telegram.
Twitter: Redesigned View Tweet dialog to make it much less cluttered.
Twitter: On Mac OS, fixes user viewer to focus a UI element if loading a single profile.
Twitter: Twitter replies are now read in the way Twitter's official app and Twitterrific for example read them. I.E. TweeseCake (Replying to username). If there are more than 2 usernames in a reply chain, the first username is listed along with the count of the remaining usernames. I.E. TweeseCake (Replying to username and 3 more).
Twitter: Conversation buffers are now labeled with the user of the conversation.
Twitter: More robust handling of SNDUp URL's.
Twitter: Add option to hide retweets of original tweets that already exist in your home buffer.
0.8.2:
Core: Add ability to run TweeseCake as a portable application; this was possible before, but the databases didn't like it.
Core: Tentative fix to stop updater breaking databases.
Telegram: Fix replying from chats buffer.
Twitter: Add filter support.
Twitter: Fix users list in reply dialog.
Twitter: When composing a tweet, you can now use alt T to tweet (Thanks Mia for suggestion)
0.8.1:
Core: Fix a number of MacOS crashes.
Feeds: Add import from OPML option.
Feeds: Change update time of feeds to 2 hours.
Feeds: Use secondary interact on an article to open it's link (either a podcast eppisode, or full article content) (if provided)
Github: Fix reading of repositories if they have no short description.
Github: Markdown tags are no longer spoken when reading issue comments.
Telegram: Play button in record voice message dialog.
Telegram: Seek+play/pause in voice messages.
Telegram: Stop copying unsupported message data to the clipboard.
Twitter: Use expanded URL rather than display URL when viewing and copying tweets.
Twitter: Fix streaming for the sent tweets buffer.
Twitter: Use alt semicolon (or control windows alt semicolon in invisible) to check the relationship status between you and another user. You can also do this in the user viewer.
0.8.0:
Feeds: Add feeds session. Supports most feed types, including podcasts.
Telegram: Fix the bug where you would get stuck in the phone number dialog after activating the cancel button.
Telegram: Tentative fix (?) for the voice message dialog breaking when using the GUI.
Twitter: If pressing the new tweet key while focused on the DM's or sent DM's buffer, it will now open a new DM dialog.
Twitter: If sending a DM from the sent DM's buffer, focus the original recipient of the sent DM rather than yourself.
Twitter: Fix thread mode.
Twitter: Include twitter username in title of auth code dialog if re-authorizing sessions.
Twitter: Re-start authorization process if configured auth credentials fail, instead of failing silently.
0.7.3:
Core: You can now put soundpacks in your TweeseCake app data folder, under sounds. If you don't have a sounds folder there already, one will be created for you on launch. On mac, this is ~/.config/TweeseCake/sounds, and is the recommended way to use Soundpacks on the platform.
Core: Command+C should now open the changelog in the config session.
Mastodon: Fixes opening URLs.
Twitter: Switched to tweepy4 (report any oddities).
Twitter: You can now hide and show retweets from the user view dialog.
Twitter: Streaming now respects users you have retweets hidden for.
Twitter: Adds reply settings.
Twitter: Adds composing of polls.
0.7.2:
Core: Reversed display of invisible hotkey list (so the description shows first; allows for quicker reading).
Config: Add hotkey to allow copying templates from the current session-related config buffer to all sessions of the same type.
GUI: Move session sound mute toggle and add volume and toggle playback items to new sound menu located on the menu bar.
Mastodon: Support writing content warnings in posts.
Mastodon: Support attaching and playing audio/media in posts.
Mastodon: Fix public timeline hot key to be alt(Option)+p.
Twitter: Add retweet template.
Twitter: Hopefully fixed some strange behavior with the update profile dialog.
0.7.1:
Core: Fix windows 11 keymap.
Mastodon: You can now log into other instances!
Mastodon: Fixes a bug where you couldn't view certain users' profiles.
Mastodon: Fixed a really stupid bug where you couldn't even open a followers or friends dialog if you had relative times enabled. Yikes.
Mastodon: Fixes a bug where you wouldn't see times if you had relative times disabled.
Mastodon: Fixed you were supposed to hear speech when following/unfollowing a user.
Mastodon: Add blocking and unblocking.
Mastodon: Add support for spoilers (Content warnings).
Mastodon: Add option to ignore content warnings, off by default.
Github: It's now possible to watch/unwatch and star/unstar repos, as well as see your watched/starred repos.
Github: You can now open a releases buffer for a repo and from there, an interact will open an assets buffer. Interact with an asset to download it in your browser.
Github: Use secondary interact on issues buffer to open the issue page in your browser.
0.7.0:
Core: Renamed tweet_open_in_web hotkey to open_in_web in the keymap.
Github: It's now possible to work with github within TweeseCake!
Mastodon: It's now possible to access Mastodon with TweeseCake!
Twitter: You can now view a user's likes from the user information dialog.
Twitter: You can now update your URL and description from the profile updater.
Twitter: There is now a hotkey in the UI to update your Twitter profile.
0.6.9:
Core: Include session name in title of delete session confirmation dialog.
Core: Add ability to mute sessions.
Core: Add ability to mute autoread for a session.
Telegram: Fix message reply dialogs to be multiline again.
Telegram: If the focused type isn't a media type, pressing secondary interact will now open a private chat buffer with the focused person.
Twitter: Fix bug that would break sessions if you answered yes to following TWCakeApp and you were already following.
Twitter: Added ability to update profile (only supports name and description currently).
Twitter: Add hotkey/option to open the focused tweet on twitter.com.
0.6.8:
GUI: Fixes initial focus in text input dialogs for Mac OS users.
Radio: Much more snappy and reliable now playing information retrieval.
Radio: Add ability to autoread now playing info.
Radio: Add control semicolon (win alt semi in invisible) to speak the URL and control shift semicolon (win alt shift semicolon) to copy the URL of a station.
Telegram: Fixes open in folder on Mac OS.
Twitter: Add ability to set a nickname for a user. Alt+N in the GUI or control+win+alt+N in the invisible interface.
0.6.7:
GUI: Performance and visual improvements.
GUI: Add clear buffer to buffer menu.
Telegram: Hopefully fixed a long-standing bug that meant you couldn't open a new private chat buffer with select people.
Telegram: You should now be able to record and send voice messages on Mac.
0.6.6:
Core: Notify user if speech setup fails (more helpful for Mac users).
Core: Set default media volume to 75% rather than 100%.
GUI: Add session config to application menu.
Telegram: Add option to autoread outgoing messages.
Telegram: Fix reading messages if said message was a reply to a deleted message.
Telegram: Switch first-load join prompt to the support group, rather than the general chat group.
Twitter: Fix retrieving user summary if a user doesn't have a bio.
Twitter: Added ability to delete tweets.
0.6.5:
Core: Update windows 11 keymap.
Core: 0% media volume now actually means 0% (muted).
File Explorer: Folder buffers are now sorted. This was a change needed for Mac OS, but you shouldn't notice a difference on Windows. If file orders seem off, let us know.
File Explorer: Changed the method used for getting drive space info, another change done mainly for mac OS support.
File Explorer: Update folders that have small amounts of items in them more frequently.
Twitter: Fixed a few bugs relating to retrieving quoted statuses and not reading some items when scrolling through your tweet buffers.
Twitter: Removes the my lists buffer and moves opening list timelines functionality into the view lists dialog (Control win alt L). Also removes the preference to show the my lists buffer, as it's now gone.
Telegram: URL's that don't start with http or https or that don't contain some other kind of URL prefix now correctly open in your default browser.
0.6.4:
Core: Updated the updater (ha ha). Hopefully people who had issues with it should no longer have said issues. Maybe.
GUI: Fix finalizing interface visually. Hopefully.
Twitter: Add thread mode checkbox to new tweet dialog. Thread mode: Send new tweet and then have another new tweet dialog pop up and send tweet as a reply.
Twitter: Added ability to clear a buffer.
Twitter: Retrieve tweets that a user is replying to. Basicly, should make conversations better.
Twitter: Better handling of quoted statuses.
File Explorer: Add bookmarks buffer! This buffer allows you to bookmark URL's for easy opening.
File Explorer: Sort shortcuts buffer by alphabetical order.
Radio: Sort favorites by alphabetical order.
Radio: Made the session name update in the GUI with the now playing data.
0.6.3:
Core: Unified the mute hotkey into 1 global hotkey, instead of telegram having it's own.
Core: Moved autoread into it's own global hotkey.
Core: Change volume algorithm that TweeseCake uses. This means that it gets much, much quieter at lower volumes.
Core: Announce volume percent, even if a sound is played (optional; enabled by default).
Config: Moved buffer-related config into it's own buffer (ha ha) before things get cluttered.
Telegram: Fix bug that meant you had to refocus a chat to change mute state again.
Twitter: Added ability to autoread buffers.
Twitter: Fix sending direct messages from the view tweet and view users dialogs.
0.6.2:
Twitter: Add option for configuring if earcons should play individually.
Twitter: Add sound for when you're mentioned or replied to as an optional earcon.
Twitter: Add many more sounds!
Telegram: Add option for configuring if earcons should play individually.
Telegram: Add sound for when you're mentioned or replied to as an optional earcon.
Telegram: Add option to show full names for users.
Telegram: A possible fix for the bug where when using the UI, and you hit stop in a record voice message dialog, it would just vanish out of thin air.
Radio: Add metadata support. Shows in session name and can be copied to clipboard.
Radio: When stopped from other sessions, no longer restarts playback when the application is next launched.
0.6.1:
Twitter: Hotfix to prevent buffers being removed in the actual session when reordering.
0.6.0:
Core: Breaking change! Overhauled the storage backend to use fewer files and folders and make future features easier to implement.
Core: Fix deleting sessions that are not initialized.
Core: Retry the license server a number of times rather than failing outright.
GUI: Add hotkeys to menu bar actions.
GUI: Add new session and remove session to application menu.
GUI: Add hotkey to Remove Session.
GUI: Add dismiss buffer to buffer menu.
Twitter: Added autocomplete for @users.
Twitter: Added the ability to re-order buffers.
Twitter: Announce when liked/unliked a tweet.
Twitter: Added recipient to title of direct message dialog.
0.5.5:
Core: Change way instance checking works.
Core: Add shortcut keys to context menu.
Core: Soundpack names are no longer case-sensative.
Twitter: Properly handle replying to users without wasting character counts. Woops.
Twitter: Speak checked or unchecked state of user selector in Reply Dialog.
Twitter: Fix streaming reconnection attempts.
File Explorer: Enable copy as path on Shortcuts buffer.
0.5.4:
Core: Hotfix.
0.5.3:
Core: Adds media item indication sound.
Core: Fix crash on startup if no microphone is available.
Telegram: Warn user if the library has issues loading.
Twitter: Implement blocking and unblocking (key shown in hotkey list alt+win+shift+H).
Twitter: Search Timelines now persist.
0.5.2:
Config: Added the ability to define how you want buffers to announce; who knows, you might want position info before the buffer name!
Core: Fix duplicate instance checking.
Core: Properly handle errors on session initialization.
GUI: Fixed sent direct messages not showing.
Twitter: You can now reply to yourself to create a thread once more.
Twitter: Prevent creating own user timeline (since sent tweets already exists).
Twitter config: Added the ability to template direct messages.
0.5.1:
Config: Allows timelines to be reversed properly both in the invisible and visible interfaces.
Config: Adds option to allow pressing enter to send tweets.
Core: Performance improvements when deleting sessions.
Core: Fix newline being inserted if sending with enter when the curser isn't at the end of the line.
GUI: Adds context menus to all session types when using the interface. Use your local applications key (or shift+F10) to access this.
Telegram: Hopefully fixed crash when catching up.
Twitter: Add send direct message sound.
Twitter: Add direct message character count.
0.5.0:
Core: Adds a UI! Read the Readme for info on the hotkeys!
Telegram: Hopefully fixes voice messages not being able to be sent for some users.
Telegram: Persist opened chat buffers.
Twitter: Search fields are now single line, meaning you can press enter to submit a search.
0.4.6:
Telegram: Fixes recording voice messages.
Telegram: use control enter to send newlines in the message field.
Twitter: Fix My Lists buffer.
0.4.5:
Core: Prevent multiple instances of the application running.
Config: Config buffers now start you at the top of them.
Telegram: Voice messages now are controlled by sound volume rather than media, and don't interrupt other playing media.
Telegram: You can now speed up and down voice messages.
Telegram: Audio files attach as audio messages.
Telegram: You can now reply to messages with a voice message.
Telegram: Voice messages by default send in mono, but have a toggle for stereo in telegram preferences.
0.4.4:
Telegram: Fix for sending voice messages to telegram not playing on iOS.
0.4.3:
Docs: No longer include keyboard shortcuts in documentation, as they're always being added and updated based on your session and keymap being used. Use windows alt shift H to bring up context sensitive hotkey help.
Docs: Added a section explaining what each session type does.
Core: Add text buffers. In text buffers, use interact to copy the current line, and secondary interact to open the text in a dialog.
Core: Separated media volume and soundpack volume.
Core: When creating a new session, focus it.
Config: Hit alt windows C to open the changelog from within the config session.
Twitter: Add the ability to perform OCR on the currently focused tweet image with windows alt O by default.
Twitter: Open a user summary in a text buffer if more than 1 user.
Twitter: Hit windows alt shift V to open a tweet summary in a text buffer.
Twitter config: Made tweets use templates.
Telegram: Add sending of voice messages support! Win alt shift V by default
Telegram: Add sending file support! Win alt shift F by default.
File explorer: Adds windows alt shift O to attempt to open a file in Tweesecake. It can play audio files and open text files at the moment.
Radio: Implemented radio session type. Allows for searching for stations and saving to a favorites buffer.
Misc: In the session manager, the OK button is now the default.
0.4.2:
Core: Vastly improved date parsing.
Core: Improve startup time and performance if your not using all session types.
Config: Add option for ask to confirm when exiting (Thanks Andre Polykanine.)
Twitter config: Add option to remove emojis from display names or just not use display names entirely.
Telegram: Fix date time not respecting settings in some situations.
0.4.1:
Docs: Made the entry about Alt+Win+P clearer in the readme.
Core: We now have a (hopefully) working auto updater!
Core: Notify user if a new update is available and how to activate the autoupdate function.
Core: Hopefully sessions delete properly now.
Config: Invoke the updater from the config session under the version option.
Config: Automatically remove session-specific buffers when moving away from the config session.
Config: Option to enable or disable word wrap in text fields.
Config: Option to use relative or absolute times. This works across all sessions.
config: If you're in absolute time, option to use 24 hour time.
Twitter: Support playing .wav files from URLs. (Thanks Gavin!)
Twitter: Add a way to like and unlike tweets without user view GUI.
twitter: Add a way to view a user's likes.
Twitter: Increase the size of the view tweet dialog's text field.
Twitter config: Add option to disable the my lists buffer.
Twitter config: Add option to disable ask to retweet.
Telegram: Perform a secondary interact on a chat in the chats buffer to mark as read without opening the chat.
Telegram: Use control windows shift M to mute and unmute chats. This only works in the chats buffer for now.
Telegram config: More config options!
File explorer: Remember the position of folders you've previously visited within the same buffer. (Thanks Brian Hartgen!)
File explorer: Speak when a copy or move operation has finished. (Thanks Brian Hartgen!)
File Explorer: Speak a drive letter if info on a drive is unable to be retrieved. This fixes the blank drives bug. (Thanks Jayson Smith for reporting!)
File Explorer: Adds a hotkey to copy the focused item's path to your clipboard. (Thanks Brian Hartgen!)
0.4.0:
Twitter: Fix streaming.
0.3.8:
Docs: There's now a small section in the readme on how to create custom keymaps.
Docs: Added a soundpacks creation section to the readme.
Docs: Fixed a typo in the readme, and made a note about the apostrophe key on UK keyboards.
Core: Load soundpack after changed in config.
Core: You can now delete sessions with alt+win+shift+delete.
Core: The account setup dialog now has labels on the fields.
Core: You can now press Alt+L for login, and alt+C for cancel in the account setup dialog.
Core: Made new keymaps inherit from the default keymap.
Core: Added reverse keymap to reverse the buffers.
Core: Added alt+win+space to speak current focused item in the buffer.
Core: Added a keymap for Windows 11 users.
Core: Added a windows 8.1 keymap.
Core: Buffers now autofocus by default when opened. If you don't like this new behavior, go to the config session and disable it.
Core/Config: If a TweeseCake folder exists in the directory the program is ran from, that is used as the config path.
Config: If adjusting the volume in the config session, a percentage is spoken now, instead of you getting no feedback.
Config: Added a version info item to the config general buffer. Interacting (alt+win+enter) will either tell you that your running the latest version, or prompt you to open the download page if a new version is available.
Twitter: The direct message viewing dialog now shows the sender in the title.
Twitter: The view dialog for tweets now wraps.
Twitter: When sending a reply, you no longer reply to yourself.
Twitter: Added streaming support to home, user timelines, mentions, lists and sent buffers.
Twitter Config: Made streaming a config option (currently disabled as default, as it's experimental).
Telegram: Added phone number format validation.
Telegram: windows alt L in telegram chats now handles all t.me links
Misc: prompt in twitter and telegram to follow TWCakeApp and join the group chat.